#include "MLista.h"

namespace MLista
{
    
    TLista CrearLista()
    {
         return NULL;
    }
    
    bool ListaVacia(TLista l)
    {
         return (l==NULL);
    }

    bool ListaLlena(TLista l)
    {
         TLista aux;
         bool llena;
         
         aux = new (TNodoLista);
         llena = (aux==NULL);
         if (!llena)
         {
            delete(aux);
         }
         
         return llena;
    }
    
    void InsertarLista(TLista &l, TMercancia m, TErrorLista &e)
    {
         TLista nuevo;
         
         if ((l==NULL) || (m.codigo < l->mercancia.codigo) ) // Inserto al principio
         {
              if (ListaLlena(l))
              {
                  e = ErrorListaLlena;
              }         
              else
              {
                  e = NoErrorLista;
                  nuevo = new (TNodoLista);
                  nuevo -> mercancia = m;
                  nuevo ->sig = l;
                  l = nuevo;
              }
         }
         else if (m.codigo == l->mercancia.codigo)  // Reemplazo
         {
                  e = NoErrorLista;
                  l->mercancia = m;
         }
         else
         {
             InsertarLista(l->sig, m, e);
         }
    }

    void MostrarLista(TLista l)
    {
         TLista ptr;
         
         ptr=l;
         while (ptr!=NULL)
         {
               EscribirMercancia(ptr->mercancia);
               ptr = ptr->sig;
         }
    }

    void EliminarLista(TLista &l, int codigo, TErrorLista &e)
    {
         TLista aux;
         
         if ( (l==NULL) || (l->mercancia.codigo > codigo) )
         {
              e = ErrorMercanciaNoEnLista;
         }
         else if (l->mercancia.codigo == codigo)
         {
              e = NoErrorLista;
              aux = l;
              l = l->sig;
              delete(aux);
         }
         else
         {
              EliminarLista(l->sig,codigo,e);
         }         
    }

    void SacarPrimeroLista(TLista &l, TMercancia &m, TErrorLista e)
    {
         TLista aux;
         
         if (l==NULL)
         {
              e = ErrorListaVacia;
         }
         else 
         {
              e = NoErrorLista;
              m = l->mercancia;
              aux = l;
              l = l->sig;
              delete(aux);
         }
    }

    void DestruirLista(TLista &l)
    {
         TLista aux;
         
         while (l!=NULL)
         {
               aux = l;
               l=l->sig;
               delete(aux);
         }
    }


}
