#include "MTransporte.h"
namespace MTransporte
{
    const char TAB = '\t';
          
    void EscribirCamion(TCamion camion)
    {
         cout << "Matricula  : " << camion.matricula << endl;
         cout << "Ao        : " << camion.year << endl;
         cout << "Coordenadas: " << endl
              << TAB << "Latitud  -> " << camion.coordenadas.latitud << endl
              << TAB << "Longitud -> " << camion.coordenadas.longitud << endl;
    }
    
    void EscribirMercancia(TMercancia m)
    {
         TCadena aux;
         
         cout << "Codigo               : " << m.codigo << endl;
         cout << "Descripcion          : " << m.descripcion << endl;
         Tipo_a_Cadena(m.tipo,aux);
         cout << "Tipo de Mercancia    : " << aux << endl;
         cout << "Matricula del camion : " << m.matricula << endl;
    }
    
   TTipo SUC(TTipo t)
   {
         return TTipo(int(t)+1);
   }
   
   void Tipo_a_Cadena(TTipo t, TCadena &s)
   {
        switch(t)
        {
            case inflamable:   CopiaCadena("inflamable",s); 
                               break;
            case contaminante: CopiaCadena("contaminante",s); 
                               break;
            case biologica:    CopiaCadena("biologica",s);
                               break;
            case radiactiva:   CopiaCadena("radiactiva",s); 
                               break;
        }
   }
   
   void Cadena_a_Tipo(TCadena s, TTipo &t, bool &ok)
   {
        TCadena aux;
        ok=false;
        
        t=inflamable;
        while ( (t<=radiactiva) && (!ok) )
        {
              Tipo_a_Cadena(t,aux);
              if (IgualCadena(s,aux))
              {
                  ok = true;
              }
              else
              {
                  t= SUC(t);
              }
        }
   }
   
   void LeerCamion(TCamion &camion)
   {
        cout << "Matricula  : ";
        cin.getline(camion.matricula,MAXCAD+1,ENTER);
        cout << "Conductor  : ";
        cin.getline(camion.nombre,MAXCAD+1,ENTER);
        cout << "Ao        : ";
        cin >> camion.year;
        cin.ignore();
        cout << "Coordenadas:" << endl 
             << TAB << "Latitud  -> ";
        cin >> camion.coordenadas.latitud;
        cin.ignore();
        cout << TAB << "Longitud -> ";
        cin >> camion.coordenadas.longitud;
        cin.ignore();
   }
   
   void LeerMercancia(TMercancia &m, TCadena matriculaCamion)
   {         
         cout << "Codigo               : ";
         cin >> m.codigo;
         cin.ignore();
         cout << "Descripcion          : ";
         cin.getline(m.descripcion,MAXCAD+1,ENTER);
         LeerTipoMercancia(m.tipo);
         CopiaCadena(matriculaCamion,m.matricula);
   }

   void LeerTipoMercancia(TTipo &tipo)
   {
         TCadena aux;
         bool ok;
         do
         {
            cout << "Tipo de Mercancia    : ";
            cin.getline(aux,MAXCAD+1,ENTER);
            Cadena_a_Tipo(aux,tipo,ok);
         } while (!ok);
        
   }
   void LeerCamionFichTXT(ifstream &fich, TCamion &camion)
   {
        fich.getline(camion.matricula,MAXCAD+1,SEP);
        fich.getline(camion.nombre,MAXCAD+1,SEP);
        fich >> camion.year;
        fich.ignore();
        fich >> camion.coordenadas.latitud;
        fich.ignore();
        fich >> camion.coordenadas.longitud;
        fich.ignore();
   }
   
   void LeerMercanciaFichTXT(ifstream &fich, TMercancia &m, TCadena matriculaCamion)
   {
        TCadena aux;
        bool ok;

        fich >> m.codigo;
        fich.ignore();
        fich.getline(m.descripcion,MAXCAD+1,SEP);
        fich.getline(aux,MAXCAD+1,ENTER);
        Cadena_a_Tipo(aux,m.tipo,ok);
        CopiaCadena(matriculaCamion,m.matricula);
   }

   void EscribirCamionFichTXT(ofstream &fich, TCamion camion)
   {
        fich << camion.matricula << SEP;
        fich << camion.nombre    << SEP;
        fich << camion.year      << SP;
        fich << camion.coordenadas.latitud << SP;
        fich << camion.coordenadas.longitud << endl;
   }
   
   void EscribirMercanciaFichTXT(ofstream &fich, TMercancia m)
   {
        TCadena aux;
        
        Tipo_a_Cadena(m.tipo,aux);
        fich << m.codigo << SP;
        fich << m.descripcion << SEP;
        fich << aux << endl;        
   }

}
