/*----------------------------------------------------------------
|	Autor:                                                        |
|	Fecha:                            Versin: 1.0	              |
|-----------------------------------------------------------------|
|	Descripcin del Programa:                                     |
|  								                                  |
| ----------------------------------------------------------------*/

// Incluir E/S y Libreras Standard
#include <iostream>
#include <fstream>
#include <cstdlib>
#include "MCadena.h"
#include "MTransporte.h"
#include "MCola.h"
#include "MLista.h"

using namespace std;
using namespace MCadena;
using namespace MTransporte;
using namespace MCola;
using namespace MLista;

// Zona de Declaracin de Constantes

// Zona de Declaracin de Tipos

// Zona de Cabeceras de Procedimientos y Funciones
char menu();
bool Confirmar();
void MostrarError(TErrorCola errorCola, TErrorLista errorLista);
void DuplicarCola(TCola &origen, TCola &destino);
void DuplicarLista(TLista &origen, TLista &destino);
void MostrarListaCamiones(TCola &cola);
void CargarTrasnsporte(TCadena nomFich,TCola &cola,TLista &lista);
void SalvarTrasnsporte(TCadena nomFich,TCadena matricula,TCola &cola,TLista &lista);
void EliminarTrasnsporte(TCadena matricula,TCola &cola,TLista &lista);
void BuscarCamion(TCola &cola, TCadena matricula, TCamion &c, bool &encontrado);
void EliminarTrasnsporteCola(TCadena matricula,TCola &cola);
void EliminarTrasnsporteLista(TCadena matricula,TLista &lista);
void MostrarCamionesTipoMercancia(TCola &cola, TLista &lista,TTipo tipo);
void MostrarCamionesTipoMercanciaUnico(TCola &cola, TLista &lista);
void MercanciaTipoUnico(TLista &lista,TCadena matricula,TTipo &tipo, bool &ok);
// Programa Principal
int main()
{
  // Zona de Declaracin de Variables del Programa principal
  char op;
  bool salir;
  TCola cola;
  TLista lista;
  TErrorLista errorLista;
  TErrorCola errorCola;
  TCamion camion;
  TMercancia mercancia;
  int codigo;
  TCadena matricula,nomFich;
  TTipo tipo;
  
  salir = false;
  cola = CrearCola();
  lista = CrearLista();
  
  while(!salir)
  {
    errorCola = NoErrorCola;
    errorLista = NoErrorLista;
    op = menu();
    cout << endl;
    
    switch(op)
    {
       case 'A': LeerCamion(camion);
                 MeterCola(cola,camion,errorCola);
                 if (errorCola==NoErrorCola)
                 {
                    cout << "Introducir otra Mercancia en el camion";
                    while ( (Confirmar()) && (errorLista==NoErrorLista) )
                    {
                       LeerMercancia(mercancia,camion.matricula);
                       InsertarLista(lista,mercancia,errorLista);
                    }
                 }
                 break;
       case 'B': MostrarListaCamiones(cola);
                 break;
       case 'C': MostrarLista(lista);
                 break;
       case 'D': cout << "Nombre del Fichero: ";
                 cin.getline(nomFich,MAXCAD+1,ENTER);
                 CargarTrasnsporte(nomFich,cola,lista);
                 break;
       case 'E': cout << "Codigo de la Mercancia: ";
                 cin >> codigo;
                 cin.ignore(); 
                 EliminarLista(lista,codigo,errorLista);
                 break;
       case 'F': cout << "Nombre del Fichero: ";
                 cin.getline(nomFich,MAXCAD+1,ENTER);
                 cout << "Matricula del Camion: ";
                 cin.getline(matricula,MAXCAD+1,ENTER);
                 SalvarTrasnsporte(nomFich,matricula,cola,lista);
                 break;
       case 'G': cout << "Matricula del Camion: ";
                 cin.getline(matricula,MAXCAD+1,ENTER);
                 EliminarTrasnsporte(matricula,cola,lista);
                 break;
       case 'H': LeerTipoMercancia(tipo);
                 MostrarCamionesTipoMercancia(cola,lista,tipo);
                 break;
       case 'I': MostrarCamionesTipoMercanciaUnico(cola,lista);
                 break;
       case 'X': salir = Confirmar();
                 cout << endl << endl;
                 break;    
    }
    MostrarError(errorCola,errorLista);
    system("Pause"); // Hacer una pausa
    system("cls");   // Borrar Pantalla
  }
  DestruirCola(cola);
  DestruirLista(lista);
  return 0;	   // Valor de retorno al S.O.
}

// Implementacin de Procedimientos y Funciones
char menu()
{
  char op;
  
  cout << "Nombre: (Apellidos, Nombre)    Curso: 1" << endl;
  cout << "Especialidad: Gestion          Grupo: A/B" << endl;
  cout << "Puesto: nmero de ordenador    Fecha: 25/06/2008" << endl;
  cout << endl;
  cout << "          Mercancas Peligrosas" << endl;
  cout << "          =====================" << endl;
  cout << "  A. Insertar transporte." << endl;
  cout << "  B. Mostrar lista de camiones." << endl;
  cout << "  C. Mostrar lista de mercancias." << endl;
  cout << "  D. Insertar transporte desde fichero de texto." << endl;
  cout << "  E. Eliminar mercancia." << endl;
  cout << "  F. Salvar transporte a fichero de texto." << endl;
  cout << "  G. Eliminar transporte." << endl;
  cout << "  H. Mostrar lista de camiones por tipo de mercancia." << endl;
  cout << "  I. Mostrar lista de camiones de tipo unico." << endl;
  cout << "  X. Salir del Programa" << endl;
  cout << endl;
  cout << "  Introduzca su opcion: " ;
  
  cin >> op;
  cin.ignore();
  op = toupper(op);
  
  while ( ((op<'A') || (op>'I')) && (op!='X') )
  {
    cout << "  Opcion Incorrecta ..." << endl;
    cout << endl;
    cout << "  Introduzca su opcion: " ;
    cin >> op;
    cin.ignore();
    op = toupper(op);  
  }
  
  return op;

}

bool Confirmar()
{ 
  char car;

  cout << "?Esta seguro(S/N)?";
  cin >> car;
  cin.ignore();
  car = toupper(car);
  
  return (car=='S');
}


void MostrarError(TErrorCola errorCola, TErrorLista errorLista)
{
     cout << endl;
     switch(errorCola)
     {
        case ErrorColaLlena: 
                   cout << "ERROR: Cola Llena." 
                        << endl; 
                   break;
        case ErrorColaVacia: 
                   cout << "ERROR: Cola Vacia." 
                        << endl; 
                   break;
        case NoErrorCola: // Me espero a ver si no hay errores en la lista
                   break;
     }
     
     switch(errorLista)
     {
        case ErrorListaLlena: 
                   cout << "ERROR: Lista Llena." 
                        << endl; 
                   break;
        case ErrorListaVacia: 
                   cout << "ERROR: Lista Vacia." 
                        << endl; 
                   break;
        case ErrorMercanciaNoEnLista:
                   cout << "ERROR: La mercancia No esta en la Lista." 
                        << endl; 
                   break;             
        case NoErrorLista: 
                   if (errorCola==NoErrorCola)
                   {
                       cout << "Operacin Realizada Correctamente ... " 
                            << endl;
                   }
                   break;
     }
     
}

void DuplicarCola(TCola &origen, TCola &destino)
{
     TCola aux;
     TCamion c;
     TErrorCola e;
     
     aux = CrearCola();
     destino = CrearCola();
     
     while (!ColaVacia(origen))
     {
           SacarCola(origen,c,e);
           MeterCola(aux,c,e);
     }

     while (!ColaVacia(aux))
     {
           SacarCola(aux,c,e);
           MeterCola(origen,c,e);
           MeterCola(destino,c,e);
     }
     
     DestruirCola(aux);
}

void DuplicarLista(TLista &origen, TLista &destino)
{
     TLista aux;
     TMercancia m;
     TErrorLista e;
     
     aux = CrearLista();
     destino = CrearLista();
     
     while (!ListaVacia(origen))
     {
           SacarPrimeroLista(origen,m,e);
           InsertarLista(aux,m,e);
     }

     while (!ListaVacia(aux))
     {
           SacarPrimeroLista(aux,m,e);
           InsertarLista(origen,m,e);
           InsertarLista(destino,m,e);
     }
     
     DestruirLista(aux);
}

void MostrarListaCamiones(TCola &cola)
{
     TCola copia;          
     TCamion c;
     TErrorCola e;
     
     DuplicarCola(cola,copia);
     
     while (!ColaVacia(copia))
     {
           SacarCola(copia,c,e);
           EscribirCamion(c);
     }

     DestruirCola(copia);
}

void CargarTrasnsporte(TCadena nomFich,TCola &cola,TLista &lista)
{
     ifstream fich;
     TCamion c;
     TMercancia m;
     TErrorCola eC;
     TErrorLista eL;
     
     fich.open(nomFich);
     if ( fich.bad() || fich.fail())
     {
          cout << "Error al Abrir el Fichero: " << nomFich << endl;
     }
     else
     {
         LeerCamionFichTXT(fich,c);
         MeterCola(cola,c,eC);
         LeerMercanciaFichTXT(fich,m,c.matricula);
         while (!fich.eof())
         {
               InsertarLista(lista,m,eL);
               LeerMercanciaFichTXT(fich,m,c.matricula);
         }
         fich.close();
     }
}

void SalvarTrasnsporte(TCadena nomFich,TCadena matricula,TCola &cola,TLista &lista)
{
     TCamion c;
     ofstream fich;
     bool encontrado;
     TLista aux;
     TMercancia m;
     TErrorLista e;
     
     BuscarCamion(cola,matricula,c,encontrado);
     if (!encontrado)
     {
        cout << "Error: El camion no se encuentra en la cola" << endl;             
     }
     else
     {     
        fich.open(nomFich);
        if ( fich.bad() || fich.fail())
        {
            cout << "Error al Crear el Fichero: " << nomFich << endl;
        }
        else
        {
            EscribirCamionFichTXT(fich,c);
            DuplicarLista(lista,aux);
            while (!ListaVacia(aux))
            {
                SacarPrimeroLista(aux,m,e);
                if (IgualCadena(m.matricula,matricula))
                {
                   EscribirMercanciaFichTXT(fich,m);
                }
            }
            DestruirLista(aux);
            fich.close();
         }
     }
}

void EliminarTrasnsporte(TCadena matricula,TCola &cola,TLista &lista)
{
     EliminarTrasnsporteCola(matricula,cola);
     EliminarTrasnsporteLista(matricula,lista);
}

void EliminarTrasnsporteCola(TCadena matricula,TCola &cola)
{
     TCola aux;
     TCamion c;
     TErrorCola e;
     
     aux = CrearCola();
     
     while (!ColaVacia(cola))
     {
           SacarCola(cola,c,e);
           if (!IgualCadena(c.matricula,matricula))
           {
              MeterCola(aux,c,e);
           }
     }

     while (!ColaVacia(aux))
     {
           SacarCola(aux,c,e);
           MeterCola(cola,c,e);
     }
     
     DestruirCola(aux);
}

void EliminarTrasnsporteLista(TCadena matricula, TLista &lista)
{
     TLista aux;
     TMercancia m;
     TErrorLista e;
     
     aux = CrearLista();
     
     while (!ListaVacia(lista))
     {
           SacarPrimeroLista(lista,m,e);
           if (!IgualCadena(m.matricula,matricula))
           {
              InsertarLista(aux,m,e);
           }
     }

     while (!ListaVacia(aux))
     {
           SacarPrimeroLista(aux,m,e);
           InsertarLista(lista,m,e);
     }
     
     DestruirLista(aux);
}

void BuscarCamion(TCola &cola, TCadena matricula, TCamion &c, bool &encontrado)
{
     TCola copia;
     TErrorCola e;
          
     encontrado=false;
     DuplicarCola(cola,copia);
     
     while ( (!ColaVacia(copia)) && (!encontrado) )
     {
           SacarCola(copia,c,e);
           encontrado = IgualCadena(c.matricula,matricula);
     }

     DestruirCola(copia);
}

void MostrarCamionesTipoMercancia(TCola &cola, TLista &lista,TTipo tipo)
{
     TLista aux;
     TCamion c;
     TMercancia m;
     TErrorLista e;
     TCadena s;
     bool ok;
     
     Tipo_a_Cadena(tipo,s);
     cout << "Listado de Camiones que transportan mercancia del tipo: " 
          << s << endl;
          
     DuplicarLista(lista,aux);
     while (!ListaVacia(aux))
     {
                SacarPrimeroLista(aux,m,e);
                if (m.tipo==tipo)
                {
                   BuscarCamion(cola, m.matricula, c,ok);
                   if (ok)
                   {
                      EscribirCamion(c);
                   }
                }
     }
     DestruirLista(aux);
}

void MostrarCamionesTipoMercanciaUnico(TCola &cola, TLista &lista)
{
     TCola copia;
     TErrorCola e;
     TCamion c;
     bool ok;
     TTipo tipo;
     TCadena s;
          
     DuplicarCola(cola,copia);
     
     while (!ColaVacia(copia))
     {
           SacarCola(copia,c,e);
           MercanciaTipoUnico(lista,c.matricula,tipo,ok);
           if (ok)
           {
              Tipo_a_Cadena(tipo,s);
              cout << "Camion que solo Transporta mercancia del tipo: " 
                   << s << endl;
              EscribirCamion(c);
           }           
     }

     DestruirCola(copia);
}

void MercanciaTipoUnico(TLista &lista,TCadena matricula,TTipo &tipo, bool &ok)
{
     TLista aux;
     TMercancia m;
     TErrorLista e;
     bool primero;
     
     DuplicarLista(lista,aux);
     ok = true;
     primero=true;
     while ( (!ListaVacia(aux)) && (ok) )
     {
        SacarPrimeroLista(aux,m,e);
        if (IgualCadena(m.matricula,matricula))
        {
            if (primero)
            {
                tipo = m.tipo;
                primero=false;
            }
            else
            {
                ok=(m.tipo==tipo);
            }
        }
     }
     DestruirLista(aux);
}
